//-------------------------------------------------------------------------------------------------
// File : GuiVS.hlsl
// Desc : Vertex Shader For ImGui.
// Copyright(c) Pocol. All right reserved.
//-------------------------------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////////////////////////
// VSInput structure
///////////////////////////////////////////////////////////////////////////////////////////////////
struct VSInput
{
    float2 Position : POSITION;     //!< ʒuW.
    float2 TexCoord : TEXCOORD;     //!< eNX`W.
    float4 Color    : COLOR;        //!< J[.    
};

///////////////////////////////////////////////////////////////////////////////////////////////////
// VSOutput structure
///////////////////////////////////////////////////////////////////////////////////////////////////
struct VSOutput
{
    float4 Position : SV_POSITION;  //!< ʒuW.
    float4 Color    : COLOR;        //!< J[.
    float2 TexCoord : TEXCOORD;     //!< eNX`W.
};

///////////////////////////////////////////////////////////////////////////////////////////////////
// Transform constant buffer
///////////////////////////////////////////////////////////////////////////////////////////////////
cbuffer Transform : register(b0)
{
    float4x4 Proj;      //!< ˉes.
};

//-------------------------------------------------------------------------------------------------
//      _VF[_CGg[|Cg.
//-------------------------------------------------------------------------------------------------
VSOutput main(VSInput input)
{
    VSOutput output = (VSOutput)0;
    
    output.Position = mul( Proj, float4(input.Position, 0.0f, 1.0f) );
    output.Color    = input.Color;
    output.TexCoord = input.TexCoord;

    return output;
}
