//-----------------------------------------------------------------------------
// File : SkyBoxPS.hlsl
// Desc : Pixel Shader For Sky Box.
// Copyright(c) Pocol. All right reserved.
//-----------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
// VSOutput structure
///////////////////////////////////////////////////////////////////////////////
struct VSOutput
{
    float4 Position : SV_POSITION;
    float3 TexCoord : TEXCOORD;
};

//-----------------------------------------------------------------------------
// Textures and Samplers.
//-----------------------------------------------------------------------------
TextureCube  CubeMap : register(t0);
SamplerState CubeSmp : register(s0);

//-----------------------------------------------------------------------------
//      CGg[|Cgł.
//-----------------------------------------------------------------------------
float4 main(const VSOutput input) : SV_TARGET0
{
    return CubeMap.SampleLevel(CubeSmp, input.TexCoord, 0);
}
