//-------------------------------------------------------------------------------------------------
// File : Gui.h
// Desc : Graphical User Interface Helper.
// Copyright(c) Pocol. All right reserved.
//-------------------------------------------------------------------------------------------------
#pragma once

//-------------------------------------------------------------------------------------------------
// Includes
//-------------------------------------------------------------------------------------------------
#include <cstdint>
#include <chrono>
#include <imgui.h>
#include <d3d12.h>
#include <ResourceUploadBatch.h>
#include <DescriptorPool.h>
#include <ConstantBuffer.h>
#include <VertexBuffer.h>
#include <IndexBuffer.h>
#include <Texture.h>


///////////////////////////////////////////////////////////////////////////////////////////////////
// Gui class
///////////////////////////////////////////////////////////////////////////////////////////////////
class Gui
{
    //=============================================================================================
    // list of friend classes and methods.
    //=============================================================================================
    friend void KickDraw(ImDrawData*);

public:
    //=============================================================================================
    // public variables.
    //=============================================================================================
    /* NOTHING */

    //=============================================================================================
    // public methods.
    //=============================================================================================

    //---------------------------------------------------------------------------------------------
    //! @brief      RXgN^ł.
    //---------------------------------------------------------------------------------------------
    Gui();

    //---------------------------------------------------------------------------------------------
    //! @brief      fXgN^ł.
    //---------------------------------------------------------------------------------------------
    ~Gui();

    //---------------------------------------------------------------------------------------------
    //! @brief      s܂.
    //!
    //! @param[in]      pDevice         foCXł.
    //! @param[in]      pPool           CBV/SRVp̃fBXNv^v[ł.
    //! @param[out]     batch           XVob`ł.
    //! @retval true    ɐ.
    //! @retval false   Ɏs.
    //---------------------------------------------------------------------------------------------
    bool Init(
        ID3D12Device*                 pDevice,
        DescriptorPool*               pPool,
        DXGI_FORMAT                   format,
        HWND                          hWnd,
        DirectX::ResourceUploadBatch& batch);

    //---------------------------------------------------------------------------------------------
    //! @brief      Is܂.
    //---------------------------------------------------------------------------------------------
    void Term();

    //---------------------------------------------------------------------------------------------
    //! @brief      `揈s܂.
    //!
    //! @param[in]      pCmdList        OtBbNXR}hXgł.
    //---------------------------------------------------------------------------------------------
    void Draw(ID3D12GraphicsCommandList* pCmdList);

    //---------------------------------------------------------------------------------------------
    //! @brief      obt@ւ܂.
    //---------------------------------------------------------------------------------------------
    void SwapBuffers();

    //---------------------------------------------------------------------------------------------
    //! @brief      EBhEbZ[W܂.
    //!
    //! @param[in]      hWnd        EBhEnhł.
    //! @param[in]      msg         EBhEbZ[Wł.
    //! @param[in]      wp          EBhEp[^ł.
    //! @param[in]      lp          EBhEp[^ł.
    //---------------------------------------------------------------------------------------------
    void MsgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);

private:
    //=============================================================================================
    // private variables.
    //=============================================================================================
    const uint32_t  MaxPrimitiveCount = 6 * 1024;

    ConstantBuffer                          m_CB[2];        //!< 萔obt@ł.
    VertexBuffer                            m_VB[2];        //!< _obt@ł.
    IndexBuffer                             m_IB[2];        //!< CfbNXobt@ł.
    Texture                                 m_Font;         //!< tHgeNX`ł.
    ComPtr<ID3D12RootSignature>             m_RootSig;      //!< [gVOj`ł.
    ComPtr<ID3D12PipelineState>             m_PSO;          //!< pCvCXe[gł.
    ID3D12GraphicsCommandList*              m_pCmdList;     //!< OtBbNXR}hXgł.
    int                                     m_Index;        //!< obt@ԍł.
    std::chrono::system_clock::time_point   m_LastTime;     //!< Ō̍XVł.

    //=============================================================================================
    // private methods.
    //=============================================================================================

    //---------------------------------------------------------------------------------------------
    //! @brief      `掞̏ł.
    //!
    //! @param[in]      pData       ImGui̕`f[^ł.
    //---------------------------------------------------------------------------------------------
    void OnDraw(ImDrawData* pData);
};