//-----------------------------------------------------------------------------
// File : GGXVS.hlsl
// Desc : GGX Lighting Vertex Shader.
// Copyright(c) Pocol. All right reserved.
//-----------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
// VSInput structure
///////////////////////////////////////////////////////////////////////////////
struct VSInput
{
    float3  Position : POSITION;    // ʒuWł.
    float3  Normal   : NORMAL;      // @xNgł.
    float2  TexCoord : TEXCOORD;    // eNX`Wł.
    float3  Tangent  : TANGENT;     // ڐxNgł.
};

///////////////////////////////////////////////////////////////////////////////
// VSOutput structure
///////////////////////////////////////////////////////////////////////////////
struct VSOutput
{
    float4  Position : SV_POSITION;     // ʒuWł.
    float2  TexCoord : TEXCOORD;        // eNX`Wł.
    float3  Normal   : NORMAL;          // @xNgł.
    float3  WorldPos : WORLD_POS;       // [hԂ̈ʒuWł.
};

///////////////////////////////////////////////////////////////////////////////
// Transform constant buffer
///////////////////////////////////////////////////////////////////////////////
cbuffer Transform : register( b0 )
{
    float4x4 World : packoffset( c0 ); // [hsł.
    float4x4 View  : packoffset( c4 ); // r[sł.
    float4x4 Proj  : packoffset( c8 ); // ˉesł.
}

//-----------------------------------------------------------------------------
//      _VF[_̃CGg[|Cgł.
//-----------------------------------------------------------------------------
VSOutput main( VSInput input )
{
    VSOutput output = (VSOutput)0;

    float4 localPos = float4( input.Position, 1.0f );
    float4 worldPos = mul( World, localPos );
    float4 viewPos  = mul( View,  worldPos );
    float4 projPos  = mul( Proj,  viewPos );

    output.Position = projPos;
    output.TexCoord = input.TexCoord;
    output.Normal   = normalize( mul((float3x3)World, input.Normal ) );
    output.WorldPos = worldPos.xyz;

    return output;
}